VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWinVersion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function IsWow64Process Lib "kernel32" (ByVal hProcess As Long, _
        ByRef Wow64Process As Long) As Long
        
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) _
        As Long
        
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" _
        (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, _
        ByVal samDesired As Long, phkResult As Long) As Long
        
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias _
        "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
        ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) _
        As Long

Private Type OSVERSIONINFOEX
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
    wServicePackMajor As Integer
    wServicePackMinor As Integer
    wSuiteMask As Integer
    bProductType As Byte
    bReserved As Byte
End Type


Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" _
        (VersionInfo As OSVERSIONINFOEX) As Long

Private Const OSVERSIONINFOSIZE = 148

Private Const VER_PLATFORM_WIN32s = 0
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32_NT = 2

Private Const VER_NT_WORKSTATION = 1
Private Const VER_NT_SERVER = 3

Private Const VER_SUITE_PERSONAL = 2
Private Const VER_SUITE_DATACENTER = 4
Private Const VER_SUITE_ENTERPRISE = 5

Public Enum WindowsConstants
    WinNT3 = 1
    WinNT4
    Win2000
    WinXP
    Win95
    Win98
    WinME
    Win32s
End Enum

Public Enum WindowsInfoConstants
    HomeEdition = 1
    Professional
    Server
    ServerDataCenter
    ServerAdvanced
    OSR2
    SE
End Enum

Private m_WindowsName As String
Private m_WindowsShortName As String
Private m_WindowsType As WindowsConstants
Private m_WindowsInfo As WindowsInfoConstants
Private m_IsNT As Boolean
Private m_ServicePack As String
Private m_NTVersion As String
Private m_NTBuild As String

Private Sub Class_Initialize()
    Call GetOs
End Sub

Public Property Get IsNT() As Boolean
    IsNT = m_IsNT
End Property

Public Property Get NTVersion() As String
    NTVersion = m_NTVersion
End Property

Public Property Get ServicePack() As String
   ServicePack = m_ServicePack
End Property

Public Property Get NTBuild() As String
    NTBuild = m_NTBuild
End Property

Public Property Get WindowsName() As String
    WindowsName = Trim$(m_WindowsName)
End Property

Public Property Get WindowsShortName() As String
    WindowsShortName = Trim$(m_WindowsShortName)
End Property

Public Property Get WindowsType() As WindowsConstants
    WindowsType = m_WindowsType
End Property

Public Property Get WindowsInfo() As WindowsInfoConstants
    WindowsInfo = m_WindowsInfo
End Property

Public Property Get WindowsInfoText() As String
    Select Case m_WindowsInfo
        Case HomeEdition:       WindowsInfoText = "Home Edition"
        Case Professional:      WindowsInfoText = "Professional"
        Case Server:            WindowsInfoText = "Server"
        Case ServerDataCenter:  WindowsInfoText = "Server Data Center"
        Case ServerAdvanced:    WindowsInfoText = "Server Advanced"
        Case OSR2:              WindowsInfoText = "OSR2"
        Case SE:                WindowsInfoText = "SE"
    End Select
    
End Property

Public Property Get Windows32s() As Boolean
   Windows32s = (m_WindowsType = Win32s)
End Property

Public Property Get Windows95() As Boolean
   Windows95 = (m_WindowsType = Win95)
End Property

Public Property Get Windows98() As Boolean
   Windows98 = (m_WindowsType = Win98)
End Property

Public Property Get WindowsME() As Boolean
   WindowsME = (m_WindowsType = WinME)
End Property

Public Property Get WindowsNT3() As Boolean
   WindowsNT3 = (m_WindowsType = WinNT3)
End Property

Public Property Get WindowsNT4() As Boolean
   WindowsNT4 = (m_WindowsType = WinNT4)
End Property

Public Property Get Windows2000() As Boolean
   Windows2000 = (m_WindowsType = Win2000)
End Property

Public Property Get WindowsXP() As Boolean
   WindowsXP = (m_WindowsType = WinXP)
End Property

Private Sub GetOs()
    Dim VerInfo As OSVERSIONINFOEX, bOsVersionInfoEx As Long

        VerInfo.dwOSVersionInfoSize = Len(VerInfo)
        bOsVersionInfoEx = GetVersionEx(VerInfo)
        
        If bOsVersionInfoEx = 0 Then
            VerInfo.dwOSVersionInfoSize = OSVERSIONINFOSIZE
            GetVersionEx VerInfo
        End If

        Select Case VerInfo.dwPlatformId
      
            Case VER_PLATFORM_WIN32_NT:

                                            If VerInfo.dwMajorVersion < 4 Then
                                                m_WindowsName = "Windows NT 3"
                                                m_WindowsShortName = "Windows NT 3"
                                                m_WindowsType = WinNT3
                                            ElseIf VerInfo.dwMajorVersion = 4 Then
                                                m_WindowsName = "Windows NT 4"
                                                m_WindowsShortName = "Windows NT 4"
                                                
                                                m_WindowsType = WinNT4
                                            ElseIf VerInfo.dwMajorVersion = 5 And VerInfo.dwMinorVersion = 0 Then
                                                m_WindowsName = "Windows 2000 "
                                                m_WindowsShortName = "Windows 2000"
                                                
                                                m_WindowsType = Win2000
                                            ElseIf VerInfo.dwMajorVersion = 5 And VerInfo.dwMinorVersion = 1 Then
                                                m_WindowsName = "Windows XP "
                                                m_WindowsShortName = "Windows XP"
                                                
                                                m_WindowsType = WinXP
                                            End If
             
                                            If bOsVersionInfoEx Then
                                                If VerInfo.bProductType = VER_NT_WORKSTATION Then
                                                    If VerInfo.wSuiteMask And VER_SUITE_PERSONAL Then
                                                        m_WindowsName = m_WindowsName & "Home Edition "
                                                        m_WindowsInfo = HomeEdition
                                                    Else
                                                        m_WindowsName = m_WindowsName & "Professional "
                                                        m_WindowsInfo = Professional
                                                    End If
                                                ElseIf VerInfo.bProductType = VER_NT_SERVER Then
                                                    If VerInfo.wSuiteMask And VER_SUITE_DATACENTER Then
                                                        m_WindowsName = m_WindowsName & "DataCenter Server "
                                                        m_WindowsInfo = ServerDataCenter
                                                    ElseIf VerInfo.wSuiteMask And VER_SUITE_ENTERPRISE Then
                                                        m_WindowsName = m_WindowsName & "Advanced Server "
                                                        m_WindowsInfo = ServerAdvanced
                                                    Else
                                                        m_WindowsName = m_WindowsName & "Server "
                                                        m_WindowsInfo = Server
                                                    End If
                                                End If
                                            Else
             
                                                Select Case UCase$(GetSetting("SYSTEM\CurrentControlSet\Control\ProductOptions", "ProductType", 0))
                                                    Case "WINNT":       m_WindowsName = m_WindowsName & "Professional "
                                                                        m_WindowsInfo = Professional
                                                                        
                                                    Case "LANMANNT":    m_WindowsName = m_WindowsName & "Server "
                                                                        m_WindowsInfo = Server
                                                                        
                                                    Case "SERVERNT":    m_WindowsName = m_WindowsName & "Advanced Server "
                                                                        m_WindowsInfo = ServerAdvanced
                                                End Select
                                            End If
            
                                            '------------------------------------
                                            m_NTBuild = CStr(VerInfo.dwBuildNumber And &HFFFF)
                                            If VerInfo.dwMajorVersion <= 4 Then
                                                m_NTVersion = VerInfo.dwMajorVersion & "." & VerInfo.dwMinorVersion & VerInfo.szCSDVersion
                                                m_WindowsName = m_WindowsName & "version " & m_NTVersion & " (Build " & m_NTBuild & ")"
                                            Else
                                                m_NTVersion = Trim$(VerInfo.szCSDVersion)
                                                m_WindowsName = m_WindowsName & m_NTVersion & " (Build " & m_NTBuild & ")"
                                            End If
                                            
                                            m_ServicePack = CStr(VerInfo.wServicePackMajor) & "." & CStr(VerInfo.wServicePackMinor)
                                            m_WindowsName = m_WindowsName & ", service pack " & m_ServicePack
                                            m_IsNT = True
    

                                        
            Case VER_PLATFORM_WIN32_WINDOWS:
    
                                            If VerInfo.dwMajorVersion = 4 And VerInfo.dwMinorVersion = 0 Then
                                                m_WindowsName = "Windows 95 "
                                                m_WindowsType = Win95
                                                If Mid$(VerInfo.szCSDVersion, 1, 1) = "C" Or Mid$(VerInfo.szCSDVersion, 1, 1) = "B" Then
                                                    m_WindowsName = m_WindowsName & "OSR2 "
                                                    m_WindowsInfo = OSR2
                                                End If
                                                m_WindowsShortName = Trim$(m_WindowsName)
                                                
                                            ElseIf VerInfo.dwMajorVersion = 4 And VerInfo.dwMinorVersion = 10 Then
                                                m_WindowsName = "Windows 98 "
                                                
                                                m_WindowsType = Win98
                                                If Mid$(VerInfo.szCSDVersion, 1, 1) = "A" Then
                                                    m_WindowsName = m_WindowsName & "SE "
                                                    m_WindowsInfo = SE
                                                End If
                                                m_WindowsShortName = Trim$(m_WindowsName)
                                            ElseIf VerInfo.dwMajorVersion = 4 And VerInfo.dwMinorVersion = 90 Then
                                                m_WindowsType = WinME
                                                m_WindowsShortName = "Windows Me"
                                                m_WindowsName = "Windows Me "
                                            End If

            Case VER_PLATFORM_WIN32s:
                                            m_WindowsName = "Win32s "
                                            m_WindowsShortName = "Win32s"
                                            m_WindowsType = Win32s

        End Select

        m_WindowsName = Trim$(m_WindowsName)
End Sub


Private Function GetSetting(ByRef sSubKeys As String, ByRef sValName As String, ByRef lType As Long) As String
  
    Dim lResult As Long
    Dim lKey As Long
    Dim lHandle As Long
    Dim lData As Long
    Dim sRet As String
    
    Const HKEY_LOCAL_MACHINE = &H80000002
  
        If RegOpenKeyEx(HKEY_LOCAL_MACHINE, sSubKeys, 0&, &H20019, lHandle) Then
            lResult = RegQueryValueEx(lHandle, sValName, 0&, lType, ByVal sRet, lData)
            sRet = Space(lData)
            lResult = RegQueryValueEx(lHandle, sValName, 0&, lType, ByVal sRet, lData)
            RegCloseKey lHandle
            GetSetting = sRet
        End If
  
End Function


Private Function Trim(ByVal sString1 As String) As String
    Trim = LTrim(RTrim(sString1))
End Function


' like VBA LTrim, but removes spaces, nulls (Chr 0) and tabs
Private Function LTrim(ByVal sString1 As String) As String
    Dim i
    
        For i = 1 To Len(sString1)
            Select Case Asc(Mid$(sString1, i, 1))
                Case 0, 9, 15, 32 ' remove 0, 9, 15 and 32
                                    sString1 = Mid$(sString1, i + 1)
                Case Else:          Exit For
            End Select
        Next i
        
        LTrim = sString1
End Function

' like VBA RTrim, but removes spaces, nulls (Chr 0) and tabs
Private Function RTrim(ByVal sString1 As String) As String
    Dim i
        
        For i = Len(sString1) To 1 Step -1
            Select Case Asc(Mid$(sString1, i, 1))
                Case 0, 9, 15, 32 ' remove 0, 9, 15 and 32
                                    sString1 = Left$(sString1, i - 1) + Mid$(sString1, i + 1)
                Case Else
                                Exit For
            End Select
        Next i
    
    RTrim = sString1
End Function

Public Function IsWow64() As Boolean
    Dim Wow64Process As Long
    
        On Error GoTo myError
    
            IsWow64Process GetCurrentProcess, Wow64Process
            IsWow64 = Wow64Process <> 0
    
myExit:
        Exit Function

myError:
        Resume myExit
End Function




